//Daniel Buret 20/01/2023
//Test 2 moteurs pas à pas

#include <Stepper.h>

//Contantes et Variables
String commande=""; //variable pour mémoriser les commandes d'un programme Logo
double peri=19.635; //peri = 3,1416*6.25 (périmètre roue de diamètre 6.25 cm, distance pour un tour)
double disang=0.1265; //disang = 3,1416*14,5/360 (distance à parcourir pour 1 degré avec une distance inter-roues de 14,5 cm)
const int pasParTour = 2048;

//Initialisation des moteurs
Stepper MoteurPasAPasD(pasParTour, 4, 6, 5, 7);// initialiSe la librairie du moteur droit avec les pins de 4 à 7 
Stepper MoteurPasAPasG(pasParTour, 8, 10, 9, 11);//initialiSe la librairie du moteur droit avec les pins de 8 à 11
 
//Fonctions
void ExeCom(String comdir){
  String com=""; String numcom=""; int ncom;
  com=comdir.substring(0,2);//la chaîne com contient les deux premiers caractères de la chaîne comdir (AV, RE TD ou TG)
  numcom=comdir.substring(2);//la chaine numcon contient le reste de la chaine (chiffres : nb pas ou angle)
  ncom = numcom.toInt();//conversion de la chaîne numcom en nombre entier
  Moteurs(com,ncom); //appel de la fonction Moteurs avec deux paramètres : com et ncom
}

void Moteurs(String commande, int pasang){
  double nbtour=0;
  if(commande=="AV"){
    nbtour=pasang/peri;
    for(int i=0; i<nbtour*pasParTour; i++){
      MoteurPasAPasD.step(1);
      MoteurPasAPasG.step(1);
    }
  }
  if(commande=="RE"){
    nbtour=pasang/peri;
    for(int j=0; j<nbtour*pasParTour; j++){
      MoteurPasAPasD.step(-1);
      MoteurPasAPasG.step(-1);
    }
  }  
  if(commande=="TD"){
    nbtour=(pasang*disang)/peri; //Serial.print(nbtour);
    for(int m=0; m<nbtour*pasParTour; m++){
      MoteurPasAPasD.step(-1);
      MoteurPasAPasG.step(1); 
    }
  }
  if(commande=="TG"){
    nbtour=(pasang*disang)/peri; //Serial.print(nbtour);
    for(int n=0; n<nbtour*pasParTour; n++){
      MoteurPasAPasD.step(1);
      MoteurPasAPasG.step(-1); 
    }
  }
}

void setup(){
  MoteurPasAPasD.setSpeed(9);// applique une vitessese de 9 (le maximum est 10)
  MoteurPasAPasG.setSpeed(9);
}

void loop(){
  ExeCom("AV10");
  delay(1000);
  ExeCom("RE10");
  delay(1000);
  ExeCom("TD90");
  delay(1000);
  ExeCom("TG90");
  delay(1000);
}
